﻿using System;

namespace Gildor.SimpleHostMonitor.Desktop.Entities
{
    /// <summary>
    /// The token used in a monitor operation.
    /// </summary>
    public class MonitorOperationToken
    {
        public HostInfo Host { get; set; }

        public DateTime OperationTime { get; set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="MonitorOperationToken"/> class.
        /// </summary>
        /// <param name="host">The host.</param>
        /// <param name="operationTime">The operation start time.</param>
        public MonitorOperationToken (HostInfo host, DateTime operationTime)
        {
            Host = host;
            OperationTime = operationTime;
        }
    }
}
